// Stepper.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"





#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <time.h>

//#define _WIN32_WINNT 0x0400
#define _WIN32_DCOM




//#include <windows.h>
#include "basetsd.h"



#include "Objbase.h"
//#include "Wbemidl.h"



#include <tchar.h>
#include <setupapi.h>
#include <winspool.h>
//#include <Wbemcli.h>

#include <comdef.h>

#include "oaidl.h"
#include "Ocidl.h" 

#include "Setupapi.h"



#include "SerialClass.h"




#include "Stepper.h"



static HANDLE consoleh=NULL;


#define VSNPRINTF(a,b,c,d,e) ((((e)=_vsnprintf((a),(b),(c),(d)))<0)?((a)[(b)-1]=0,(e)):(e))

void xcprintf(char * format, ...)
{
 va_list   args;
 char      v[512];
 DWORD     numw;
// CONSOLE_SCREEN_BUFFER_INFO ConsoleScreenBufferInfo;


 if(consoleh==NULL)
 {
  FreeConsole();
  AllocConsole(); 

  consoleh=GetStdHandle(STD_OUTPUT_HANDLE);

//  GetConsoleScreenBufferInfo(consoleh,&ConsoleScreenBufferInfo);
  
//  ConsoleScreenBufferInfo.dwSize.Y=256;

//  SetConsoleScreenBufferSize(consoleh,ConsoleScreenBufferInfo.dwSize);
 }


 va_start(args, format);
 numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);
 strcat(v,"\r\n");
 WriteConsole(consoleh,v,strlen(v),&numw,NULL);

 va_end(args);
}




#ifndef _DEBUG


#define cprintf xcprintf

#else

extern int zcprintf(char * format, ...);


#define cprintf 1 || zcprintf

#endif


//----------------------------------------------------------------------------------------


#include "autohandle.h"
#include "autohmodule.h"
#include "autoheapalloc.h"


#define _countof(a) (sizeof(a)/sizeof(*(a)))


BOOL IsNumeric(char * pszString, BOOL bIgnoreColon)
{
  size_t nLen = strlen(pszString);
  if (nLen == 0)
    return FALSE;

  //What will be the return value from this function (assume the best)
  BOOL bNumeric = TRUE;

  for (size_t i=0; i<nLen && bNumeric; i++)
  {
    bNumeric = (isdigit(static_cast<int>(pszString[i])) != 0);
    if (bIgnoreColon && (pszString[i] == ':'))
      bNumeric = TRUE;
  }

  return bNumeric;
}


HMODULE LoadLibraryFromSystem32(LPCTSTR lpFileName)
{
  //Get the Windows System32 directory
  TCHAR szFullPath[_MAX_PATH];
  szFullPath[0] = _T('\0');
  if (GetSystemDirectory(szFullPath, _countof(szFullPath)) == 0)
    return NULL;

  //Setup the full path and delegate to LoadLibrary    
//  _tcscat_s(szFullPath, _countof(szFullPath), _T("\\"));
   strcat(szFullPath,_T("\\"));

//  _tcscat_s(szFullPath, _countof(szFullPath), lpFileName);
   strcat(szFullPath,lpFileName);

  return LoadLibrary(szFullPath);
}


typedef HKEY (__stdcall SETUPDIOPENDEVREGKEY)(HDEVINFO, PSP_DEVINFO_DATA, DWORD, DWORD, DWORD, REGSAM);
typedef BOOL (__stdcall SETUPDICLASSGUIDSFROMNAME)(LPCTSTR, LPGUID, DWORD, PDWORD);
typedef BOOL (__stdcall SETUPDIDESTROYDEVICEINFOLIST)(HDEVINFO);
typedef BOOL (__stdcall SETUPDIENUMDEVICEINFO)(HDEVINFO, DWORD, PSP_DEVINFO_DATA);
typedef HDEVINFO (__stdcall SETUPDIGETCLASSDEVS)(LPGUID, LPCTSTR, HWND, DWORD);
typedef BOOL (__stdcall SETUPDIGETDEVICEREGISTRYPROPERTY)(HDEVINFO, PSP_DEVINFO_DATA, DWORD, PDWORD, PBYTE, DWORD, PDWORD);



BOOL RegQueryValueString(HKEY kKey, LPCTSTR lpValueName, LPTSTR& pszValue)
{
  //Initialize the output parameter
  pszValue = NULL;

  //First query for the size of the registry value 
  DWORD dwType = 0;
  DWORD dwDataSize = 0;
  LONG nError = RegQueryValueEx(kKey, lpValueName, NULL, &dwType, NULL, &dwDataSize);
  if (nError != ERROR_SUCCESS)
  {
    SetLastError(nError);
    return FALSE;
  }

  //Ensure the value is a string
  if (dwType != REG_SZ)
  {
    SetLastError(ERROR_INVALID_DATA);
    return FALSE;
  }

  //Allocate enough bytes for the return value
  DWORD dwAllocatedSize = dwDataSize + sizeof(TCHAR); //+sizeof(TCHAR) is to allow us to NULL terminate the data if it is not null terminated in the registry
  pszValue = reinterpret_cast<LPTSTR>(LocalAlloc(LMEM_FIXED, dwAllocatedSize)); 
  if (pszValue == NULL)
    return FALSE;

  //Recall RegQueryValueEx to return the data
  pszValue[0] = _T('\0');
  DWORD dwReturnedSize = dwAllocatedSize;
  nError = RegQueryValueEx(kKey, lpValueName, NULL, &dwType, reinterpret_cast<LPBYTE>(pszValue), &dwReturnedSize);
  if (nError != ERROR_SUCCESS)
  {
    LocalFree(pszValue);
    pszValue = NULL;
    SetLastError(nError);
    return FALSE;
  }

  //Handle the case where the data just returned is the same size as the allocated size. This could occur where the data
  //has been updated in the registry with a non null terminator between the two calls to ReqQueryValueEx above. Rather than
  //return a potentially non-null terminated block of data, just fail the method call
  if (dwReturnedSize >= dwAllocatedSize)
  {
    SetLastError(ERROR_INVALID_DATA);
    return FALSE;
  }

  //NULL terminate the data if it was not returned NULL terminated because it is not stored null terminated in the registry
  if (pszValue[dwReturnedSize/sizeof(TCHAR) - 1] != _T('\0'))
    pszValue[dwReturnedSize/sizeof(TCHAR)] = _T('\0');

  return TRUE;
}



BOOL QueryRegistryPortName(HKEY hDeviceKey, int& nPort)
{
  //What will be the return value from the method (assume the worst)
  BOOL bAdded = FALSE;

  //Read in the name of the port
  LPTSTR pszPortName = NULL;
  if (RegQueryValueString(hDeviceKey, _T("PortName"), pszPortName))
  {
    //If it looks like "COMX" then
    //add it to the array which will be returned
    size_t nLen = _tcslen(pszPortName);
    if (nLen > 3)
    {
      if ((_tcsnicmp(pszPortName, _T("COM"), 3) == 0) && IsNumeric((pszPortName + 3), FALSE))
      {
        //Work out the port number
        nPort = _ttoi(pszPortName + 3);

        bAdded = TRUE;
      }
    }
    LocalFree(pszPortName);
  }

  return bAdded;
}



BOOL getcomport(int * pport)
{
  int nPort;
  *pport=-1;

  //Get the function pointers to "SetupDiGetClassDevs", "SetupDiGetClassDevs", "SetupDiEnumDeviceInfo", "SetupDiOpenDevRegKey" 
  //and "SetupDiDestroyDeviceInfoList" in setupapi.dll
  CAutoHModule setupAPI(LoadLibraryFromSystem32(_T("SETUPAPI.DLL")));
  if (setupAPI == NULL)
    return FALSE;

  SETUPDIOPENDEVREGKEY* lpfnSETUPDIOPENDEVREGKEY = reinterpret_cast<SETUPDIOPENDEVREGKEY*>(GetProcAddress(setupAPI, "SetupDiOpenDevRegKey"));
#if defined _UNICODE
  SETUPDICLASSGUIDSFROMNAME* lpfnSETUPDICLASSGUIDSFROMNAME = reinterpret_cast<SETUPDICLASSGUIDSFROMNAME*>(GetProcAddress(setupAPI, "SetupDiClassGuidsFromNameW"));
  SETUPDIGETCLASSDEVS* lpfnSETUPDIGETCLASSDEVS = reinterpret_cast<SETUPDIGETCLASSDEVS*>(GetProcAddress(setupAPI, "SetupDiGetClassDevsW"));
  SETUPDIGETDEVICEREGISTRYPROPERTY* lpfnSETUPDIGETDEVICEREGISTRYPROPERTY = reinterpret_cast<SETUPDIGETDEVICEREGISTRYPROPERTY*>(GetProcAddress(setupAPI, "SetupDiGetDeviceRegistryPropertyW"));
#else
  SETUPDICLASSGUIDSFROMNAME* lpfnSETUPDICLASSGUIDSFROMNAME = reinterpret_cast<SETUPDICLASSGUIDSFROMNAME*>(GetProcAddress(setupAPI, "SetupDiClassGuidsFromNameA"));
  SETUPDIGETCLASSDEVS* lpfnSETUPDIGETCLASSDEVS = reinterpret_cast<SETUPDIGETCLASSDEVS*>(GetProcAddress(setupAPI, "SetupDiGetClassDevsA"));
  SETUPDIGETDEVICEREGISTRYPROPERTY* lpfnSETUPDIGETDEVICEREGISTRYPROPERTY = reinterpret_cast<SETUPDIGETDEVICEREGISTRYPROPERTY*>(GetProcAddress(setupAPI, "SetupDiGetDeviceRegistryPropertyA"));
#endif
  SETUPDIDESTROYDEVICEINFOLIST* lpfnSETUPDIDESTROYDEVICEINFOLIST = reinterpret_cast<SETUPDIDESTROYDEVICEINFOLIST*>(GetProcAddress(setupAPI, "SetupDiDestroyDeviceInfoList"));
  SETUPDIENUMDEVICEINFO* lpfnSETUPDIENUMDEVICEINFO = reinterpret_cast<SETUPDIENUMDEVICEINFO*>(GetProcAddress(setupAPI, "SetupDiEnumDeviceInfo"));

  if ((lpfnSETUPDIOPENDEVREGKEY == NULL) || (lpfnSETUPDICLASSGUIDSFROMNAME == NULL) || (lpfnSETUPDIDESTROYDEVICEINFOLIST == NULL) ||
      (lpfnSETUPDIENUMDEVICEINFO == NULL) || (lpfnSETUPDIGETCLASSDEVS == NULL) || (lpfnSETUPDIGETDEVICEREGISTRYPROPERTY == NULL))
  {
    //Set the error to report
    setupAPI.m_dwError = ERROR_CALL_NOT_IMPLEMENTED;

    return FALSE;
  }
  
  //First need to convert the name "Ports" to a GUID using SetupDiClassGuidsFromName
  DWORD dwGuids = 0;
  lpfnSETUPDICLASSGUIDSFROMNAME(_T("Ports"), NULL, 0, &dwGuids);
  if (dwGuids == 0)
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Allocate the needed memory
  CAutoHeapAlloc guids;
  if (!guids.Allocate(dwGuids * sizeof(GUID)))
  {
    //Set the error to report
    setupAPI.m_dwError = ERROR_OUTOFMEMORY;

    return FALSE;
  }

  //Call the function again
  GUID* pGuids = static_cast<GUID*>(guids.m_pData);
  if (!lpfnSETUPDICLASSGUIDSFROMNAME(_T("Ports"), pGuids, dwGuids, &dwGuids))
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Now create a "device information set" which is required to enumerate all the ports
  HDEVINFO hDevInfoSet = lpfnSETUPDIGETCLASSDEVS(pGuids, NULL, NULL, DIGCF_PRESENT);
  if (hDevInfoSet == INVALID_HANDLE_VALUE)
  {
    //Set the error to report
    setupAPI.m_dwError = GetLastError();

    return FALSE;
  }

  //Finally do the enumeration
  BOOL bMoreItems = TRUE;
  int nIndex = 0;
  SP_DEVINFO_DATA devInfo;
  while (bMoreItems)
  {
    //Enumerate the current device
    devInfo.cbSize = sizeof(SP_DEVINFO_DATA);
    bMoreItems = lpfnSETUPDIENUMDEVICEINFO(hDevInfoSet, nIndex, &devInfo);
    if (bMoreItems)
    {
      //Did we find a serial port for this device
      BOOL bAdded = FALSE;

      //Get the registry key which stores the ports settings
      HKEY hDeviceKey = lpfnSETUPDIOPENDEVREGKEY(hDevInfoSet, &devInfo, DICS_FLAG_GLOBAL, 0, DIREG_DEV, KEY_QUERY_VALUE);
      if (hDeviceKey != INVALID_HANDLE_VALUE)
      {
        nPort = 0;
        if (QueryRegistryPortName(hDeviceKey, nPort))
        {
        #if defined CENUMERATESERIAL_USE_STL
//          ports.push_back(nPort);
        #else
//          ports.Add(nPort);
        #endif  
          bAdded = TRUE;
        }

        //Close the key now that we are finished with it
        RegCloseKey(hDeviceKey);
      }

      //If the port was a serial port, then also try to get its friendly name
      if (bAdded)
      {
        TCHAR szFriendlyName[1024];
        szFriendlyName[0] = _T('\0');
        DWORD dwSize = sizeof(szFriendlyName);
        DWORD dwType = 0;
        if (lpfnSETUPDIGETDEVICEREGISTRYPROPERTY(hDevInfoSet, &devInfo, SPDRP_DEVICEDESC, &dwType, reinterpret_cast<PBYTE>(szFriendlyName), dwSize, &dwSize) && (dwType == REG_SZ))
        {
        #if defined CENUMERATESERIAL_USE_STL
//          friendlyNames.push_back(szFriendlyName);
        #else
//          friendlyNames.Add(szFriendlyName);
        #endif  
//         cprintf("name %s",szFriendlyName);
         if(strstr(szFriendlyName,"Arduino"))
         {
          *pport=nPort;
         }
        }
        else
        {
        #if defined CENUMERATESERIAL_USE_STL
//          friendlyNames.push_back(_T(""));
        #else
//          friendlyNames.Add(_T(""));
        #endif  
        }
      }
    }

    ++nIndex;
  }

  //Free up the "device information set" now that we are finished with it
  lpfnSETUPDIDESTROYDEVICEINFOLIST(hDevInfoSet);

  //Return the success indicator
  return TRUE;
}




//-------------------------------------------------------------------------------------------




//CONNECT TO REMOTE HOST (CLIENT APPLICATION)
//Include the needed header files.
//Don't forget to link libws2_32.a to your program as well
#include <winsock.h>

SOCKET s; //Socket handle

//CONNECTTOHOST  Connects to a remote host
bool ConnectToHost(int PortNo, char* IPAddress)
{
    //Start up Winsock
    WSADATA wsadata;

    int error = WSAStartup(0x0202, &wsadata);

    //Did something happen?
    if (error)
        return false;

    //Did we get the right Winsock version?
    if (wsadata.wVersion != 0x0202)
    {
        WSACleanup(); //Clean up Winsock
        return false;
    }


    //Fill out the information needed to initialize a socket
    SOCKADDR_IN target; //Socket address information

    target.sin_family = AF_INET; // address family Internet
    target.sin_port = htons (PortNo); //Port to connect on
    target.sin_addr.s_addr = inet_addr (IPAddress); //Target IP

    s = socket (AF_INET, SOCK_STREAM, IPPROTO_TCP); //Create socket
    if (s == INVALID_SOCKET)
    {
        return false; //Couldn't create the socket
    }  

    //Try connecting...

    if (connect(s, (SOCKADDR *)&target, sizeof(target)) == SOCKET_ERROR)
    {
        return false; //Couldn't connect
    }
    else
	{
     u_long iMode=1;
	 ioctlsocket(s,FIONBIO,&iMode);

     char value = 1;
     setsockopt( s, IPPROTO_TCP, TCP_NODELAY, &value, sizeof( value ) );

     return true; //Success
	}
}

//CLOSECONNECTION  shuts down the socket and closes any connection on it
void CloseConnection ()
{
    //Close the socket if it exists
    if (s)
        closesocket(s);

    WSACleanup(); //Clean up Winsock
}








//-------------------------------------------------------------------------------------------


Serial* SP;


#define DEFDELAY 5000

HANDLE ghSemaphore;

static int resetflag=0;

static char * ipaddress;
static int    ipport;




static int ipread(char * p,int n)
{
//	cprintf("ipread");
 int i=(recv(s,p,n,0));


// cprintf("read char %d bytes %d",*p,i);
 return(i);
}


static int ipwrite(char * p,int n)
{
//cprintf("ipwrite %s len %d",p,n);
 send(s, p, n, 0);

 return(0);
}


static int ipreset(unsigned int time)
{


 return(0);
}




static char * readlnbase(int delay)
{
 static char buffer[1024];
 static char * p=buffer;
 static char * q=buffer;
 int           n;
 clock_t       timeout;
 


 timeout=delay+clock();

 while(1)
 {
  if(resetflag) return(NULL);

//  n=SP->ReadData(p,sizeof(buffer)-4-(p-buffer));
  if(ipaddress) n=ipread(p,1);
  else          n=SP->ReadData(p,1);

  if(n<=0)
  {
   if(clock()>timeout) return(NULL);
  }
  else
  {
//   cprintf("n chars %d ",*p);

   p+=n;
   *p=0;

//   cprintf("buffer %s",buffer);

   if((p-buffer+4)>=sizeof(buffer))
   {
    p=q=buffer;
    return(buffer);
   }

   while(q<p)
   {
    if(*q++<32)
    {
//     cprintf("read ln term %d",*(q-1));
     *(q-1)=0;
      p=q=buffer;
     if(*buffer)
	 {
	  return(buffer);
	 }

    }
   }
  }
 }
}




static int seenmove;
static int moveposn;

static char * cachedcommand=NULL;
static char   cachebuffer[1024];



static char * readlnmiddle(int delay)
{
 char * p;
 int    posn;
 int    power;
 int    cn;


 p=readlnbase(delay);
 if(p)
 {
//  cprintf("rlm %s",p);
  if((cn=sscanf(p,"mv %d %d",&posn,&power))==2)
  {
   seenmove=1;
   moveposn=posn;
  }
  else
  {
   strcpy(cachebuffer,p);
   cachedcommand=cachebuffer;
  }
//  cprintf("cn %d seenmove %d",cn,seenmove);
 }

 return(p);
}




int TestMoveOver(int * posn,int delay)
{
 clock_t timeout=delay+clock();
 DWORD dwWaitResult;


// cprintf("tm in %d",seenmove);

 while(clock()<timeout)
 {
  if(seenmove) break;
  if(resetflag) break;

  dwWaitResult=WaitForSingleObject(ghSemaphore,0L);    
  if(dwWaitResult==WAIT_OBJECT_0)
  {
   if(!seenmove) readlnmiddle(delay);
   ReleaseSemaphore(ghSemaphore,1,NULL);
  }
  Sleep(100);
 }

// cprintf("tm ex %d",seenmove);

 if(resetflag) return(2);
 if(posn) *posn=moveposn;
 return(seenmove);
}







char * readln(int delay)
{
 char * p;
 clock_t timeout=delay+clock();
 DWORD dwWaitResult;


 while(clock()<timeout)
 {
  if(cachedcommand) break;
  if(resetflag) break;

cprintf("read ln 1");

  dwWaitResult=WaitForSingleObject(ghSemaphore,0L);    
  if(dwWaitResult==WAIT_OBJECT_0)
  {
	  cprintf("read ln 3");
   if(!cachedcommand) readlnmiddle(delay);
   ReleaseSemaphore(ghSemaphore,1,NULL);
  }
  Sleep(100);
 }

cprintf("read ln 2");

 if(resetflag) return(NULL);
 p=cachedcommand;
 cachedcommand=NULL;
 return(p); 
}




int writeserialport(int delay,char * format, ...)
{
 char v[1024];
 int  numw;
  va_list   args;
 DWORD dwWaitResult;

 

 if(resetflag) return(2);

 dwWaitResult=WaitForSingleObject(ghSemaphore,delay);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  va_start(args, format);
  numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);

  va_end(args);


  if(ipaddress) ipwrite(v,strlen(v));
  else       
  if(SP) SP->WriteData(v,strlen(v));

  ReleaseSemaphore(ghSemaphore,1,NULL);
 }

 return(0);
}




STEPPER_API int ResetArduino(unsigned int timeout)
{
 DWORD dwWaitResult;

 cprintf("doing reset");
 
 dwWaitResult=WaitForSingleObject(ghSemaphore,timeout);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  if(ipaddress) ipreset(timeout);
  else 
  if(SP) SP->Reset(timeout);

  ReleaseSemaphore(ghSemaphore,1,NULL);
 }

 return(0);
}



STEPPER_API int SetCancelState(int state)
{

 cprintf("set cancel flag %d",state);

 resetflag=state;

 return(0);
}





char * writeresponse(int delay,char * format, ...)
{
 char v[1024];
 int  numw;
 va_list   args;
 DWORD dwWaitResult;
 clock_t timeout=delay+clock();
 char * p=NULL;



 if(resetflag) return(NULL);

 dwWaitResult=WaitForSingleObject(ghSemaphore,delay);    
 if(dwWaitResult==WAIT_OBJECT_0)
 {
  va_start(args, format);
  numw=VSNPRINTF(v,(sizeof(v)-2)/sizeof(TCHAR),format,args,numw);

  va_end(args);

  if(SP || ipaddress)
  {
	  cprintf("write response");

   if(ipaddress) ipwrite(v,strlen(v));
   else          SP->WriteData(v,strlen(v));

   while(clock()<timeout)
   {
    if(resetflag) break;
    if(cachedcommand) break;
    readlnmiddle(delay);
   }
   p=cachedcommand;
   cachedcommand=NULL;
  }
  ReleaseSemaphore(ghSemaphore,1,NULL);
 }



 return(p);
}



int dbprint(char * string)
{

 cprintf(string);
 return(0);
}



void stepperexit(void)
{

 
}



#define MAX_SEM_COUNT 1







STEPPER_API int InitStp()
{
 int  port;
 char buffer[64];


 if(!getcomport(&port)) return(1);
 if(port<0) return(2);

// port=6;

 cprintf("Module start using port %d",port);

 if(port<10) sprintf(buffer,"COM%d",port);
 else        sprintf(buffer,"\\\\.\\COM%d",port);

 SP = new Serial(buffer);    // adjust as needed

 if (SP->IsConnected()) cprintf("We're connected");
 else                   return(3);

 ghSemaphore = CreateSemaphore( 
        NULL,           // default security attributes
        MAX_SEM_COUNT,  // initial count
        MAX_SEM_COUNT,  // maximum count
        NULL);       

 if(ghSemaphore==NULL) cprintf("CreateSemaphore error: %d\n", GetLastError());


 return(0);
}





STEPPER_API int InitStp2(char * ipx,int portx)
{
 ipaddress=ipx;
 ipport=portx;

  

cprintf("stp2 %s %d",ipx,portx);

 if(ipx==NULL || ((*ipx)==0))
 {
  ipaddress=NULL;
  return(InitStp());
 }

cprintf("con host");

 if(!ConnectToHost(portx,ipx)) return(1);

cprintf("stp 2 create semaphore");

 ghSemaphore = CreateSemaphore( 
        NULL,           // default security attributes
        MAX_SEM_COUNT,  // initial count
        MAX_SEM_COUNT,  // maximum count
        NULL);       

 if(ghSemaphore==NULL) cprintf("CreateSemaphore error: %d\n", GetLastError());


 cprintf("We're connected to network");


 //writeresponse(DEFDELAY,"ve\n");
//writeresponse(DEFDELAY,"ve\n");
//writeresponse(DEFDELAY,"ve\n");

/*
 int n=0;
 char buffer2[1024];
 while(1)
 {
  char * p;
  //ipwrite("hello\r\n",7);
  writeserialport(DEFDELAY,"hello\n");
  memset(buffer2,0,sizeof(buffer2));
  //ipread(buffer2,256);
  
  
  p=readln(DEFDELAY);
  
  if(p) cprintf("read data %s",p);
  else  cprintf("read null %s",ipaddress);
  n++;
  if(n>10) break;
 }
 ipaddress=NULL;

 return(2); 
*/

 return(0);
}





/*
Steps - integer in the range 1 to 16000 corresponding to the number of steps to execute
Interval integer in the range1 to 16000 corresponding to the time interval in milli-seconds between each step.
Direction integer in the range 0 to 1. Zero corresponds to forward and 1 to reverse.
Outputs integer in the range 0 to 7 corresponding to the bit pattern for on/off of the additional switching outputs associated with motor 1. e.g. a value of 5 (which is 00000101 in binary) would result in outputs 1 and 3 being
*/




int m1steps;
int m1interval;
int m1direction;
int m1outputs;



STEPPER_API int   RunMotor1(int steps, int interval, int direction, int outputs)
{
 int stepspersecond;

 cprintf("run motor 1 steps %d interval %d direction %d outputs %x",steps,interval,direction,outputs);

 m1steps=steps;
 m1interval=interval;
 m1direction=direction;
 m1outputs=outputs;

 stepspersecond=1000/interval;
 if(stepspersecond<=0) stepspersecond=1;
 if(m1direction) steps=-steps;

 writeserialport(DEFDELAY,"sp %d\n",stepspersecond);
 writeserialport(DEFDELAY,"ac %d\n",stepspersecond);
 writeserialport(DEFDELAY,"mv %d\n",steps);

 return(0);
}


/*
This simply terminates the current task being performed by motor1 immediately while updating the current state of the other switching outputs.
*/


STEPPER_API int   StopMotor1(int outputs)
{
 
 cprintf("stop motor 1 outputs %x",outputs);
 m1steps=0;

 writeserialport(DEFDELAY,"xx\n");

 return(0);
}




/*
The StepMode can be set to one of three possible options Wave Step, Full Step and Power Off.
The SetStepMode() function has therefore three possible values for its parameters M1Mode and M2Mode.
A 0. sets Wavestep mode, a 1. sets Full step mode and a 2. sets power-off mode
*/


STEPPER_API int   SetStepMode(int M1Mode, int M2Mode)
{

 cprintf("set stepmode M1=%d M2=%d",M1Mode,M2Mode);

 if(M1Mode==2)
 {
  writeserialport(DEFDELAY,"pw 0\n");
 }
 else
 if(M1Mode==1 || M1Mode==0)
 {
  writeserialport(DEFDELAY,"pw 0\n");
 }

 return(0);
}



/*

M1Active set to 1 for motor1 active, 0 for motor1 stopped.
M2Active set to 1 for motor2 active, 0 for motor2 stopped.
M1Steps integer in the range 0  16000 corresponding to the number of steps motor1 has left to complete.
M2Steps integer in the range 0  16000 corresponding to the number of steps motor2 has left to complete.
Inputs integer in the range 0  31 corresponding to the bit pattern of the current digital inputs. (bit 0 corresponds to input 1, bit 1 to input 2, etc)


*/



STEPPER_API int   GetCurrentStatus(int *M1Active, int *M2Active, int *M1Steps, int *M2Steps,  int *Inputs)
{

 *M1Active=(m1steps>0);
 *M2Active=0;
 *M1Steps=m1steps;
 *M2Steps=0;
 *Inputs=0;

 //cprintf("get status");


 return(0);
}



STEPPER_API int   RunMotor2(int steps, int interval, int direction, int outputs)
{

//  cprintf("run motor 2 steps %d interval %d direction %d outputs %x",steps,interval,direction,outputs);


 return(0);
}


STEPPER_API int StopMotor2(int outputs)
{

 cprintf("stop motor 2 outputs %x",outputs);
 

 return(0);
}






STEPPER_API int RunSpeed(int speed)
{


  cprintf("run speed %d",speed);

 writeserialport(DEFDELAY,"rs %d\n",speed);

// p=writeresponse(DEFDELAY,"rs %d\n",speed);
//  if(p) cprintf("run sp %s",p);

 return(0);
}






STEPPER_API int SetSpeedMotor1(int speed)
{
 cprintf("speed motor 1 %d",speed);

 writeserialport(DEFDELAY,"sp %d\n",speed);

 return(0);
}




STEPPER_API int SetAccelerationMotor1(int acc)
{
 cprintf("acc motor 1 %d",acc);

 writeserialport(DEFDELAY,"ac %d\n",acc);

 return(0);
}




STEPPER_API int MoveMotor1(int steps)
{
 cprintf("move motor 1 %d",steps);
 seenmove=0;

 writeserialport(DEFDELAY,"mv %d\n",steps);

 return(0);
}



STEPPER_API int MoveToMotor1(int steps)
{
 cprintf("move To motor 1 %d",steps);
 seenmove=0;

 writeserialport(DEFDELAY,"mt %d\n",steps);

 return(0);
}



STEPPER_API int SetCurPos(int steps)
{
 cprintf("set cur pos %d",steps);

 writeserialport(DEFDELAY,"sc %d\n",steps);

 return(0);
}



STEPPER_API int StepSizeMotor1(int steps)
{
 cprintf("step size motor 1 %d",steps);

 writeserialport(DEFDELAY,"ss %d\n",steps);

 return(0);
}



STEPPER_API int PowerMotor1(int pw)
{
 cprintf("power motor %d",pw);

 writeserialport(DEFDELAY,"pw %d\n",pw);

 return(0);
}



STEPPER_API int WritePin(int pin,int value)
{
 cprintf("write pin %d %d",pin,value);

 writeserialport(DEFDELAY,"wr %d %d\n",pin,value);

 return(0);
}


STEPPER_API int ArmInterrupt(int interrupt,int mode)
{
 cprintf("arm interrupt %d %d",interrupt,mode);

 writeserialport(DEFDELAY,"ai %d %d\n",interrupt,mode);

 return(0);
}


STEPPER_API int RemInterrupt(int interrupt)
{
 cprintf("rem interrupt %d",interrupt);

 writeserialport(DEFDELAY,"ri %d\n",interrupt);

 return(0);
}




STEPPER_API int SendCommand(char * string)
{
 cprintf("send command %s",string);

 writeserialport(DEFDELAY,"%s\n",string); 

 return(0);
}



STEPPER_API int GetResponse(char ** string,int delay)
{
 char * p;

 p=readln(delay);
 
 if(p)
 {
   cprintf("get response %d %s len=%d",delay,p,strlen(p));
  *string=p;
  return(0);
 }

 return(1);
}








STEPPER_API int GetPosition(void)
{
 char * p;
 int    value;

 cprintf("get position function");
 if((!SP) && (!ipaddress)) return(0);

 p=writeresponse(DEFDELAY,"ps\n");
 if(p)
 {
  value=0;
  cprintf("get pos result %s",p);
  sscanf(p,"ps %d",&value);
  return(value);
 }

 cprintf("get pos times out");
 
 return(0);
}



STEPPER_API int GetDistanceToGo(void)
{
 char * p;
 int    value;


  cprintf("get distance to go");
 p=writeresponse(DEFDELAY,"ds\n");
 if(p)
 {
  value=0;
  sscanf(p,"ds %d",&value);
  return(value);
 }
 return(0);
}



STEPPER_API int ReadPin(int pin)
{
 char * p;
 int    value;


  cprintf("read pin %d",pin);

 p=writeresponse(DEFDELAY,"rd %d\n",pin);
 if(p)
 {
  value=0;
  sscanf(p,"rd %d",&value);
  cprintf("read pin %d value %d string %s",pin,value,p);
  return(value);
 }
 return(0);
}





STEPPER_API int TestSensor(int pin)
{
 char * p;
 int    value;


  cprintf("test pin %d",pin);

 p=writeresponse(DEFDELAY,"ts %d\n",pin);
 if(p)
 {
  value=0;
  sscanf(p,"ts %d",&value);
  cprintf("test pin %d value %d string %s",pin,value,p);
  return(value);
 }
 return(0);
}




STEPPER_API int GetProcessor(void)
{
 char * p;
 int    value;


 cprintf("get processor");

 p=writeresponse(DEFDELAY,"pr\n");
 if(p)
 {
  value=0;
  sscanf(p,"pr %x",&value);
  cprintf("get processor %x string %s",value,p);
   
  return(value);
 }
 return(0);
}





BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
    switch (ul_reason_for_call)
	{

		case DLL_THREAD_DETACH:
                         stepperexit();
                         break;

		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:

		case DLL_PROCESS_DETACH:
			break;
    }
    return TRUE;
}


